function trim(str){
  trim_str = str;
  gsub(/^ +/,"",trim_str);
  gsub(/ +$/,"",trim_str);
  gsub(/ {2,}/," ",trim_str);
  return trim_str;
}

function HTML_restore(str,   s){
  s = str;
  gsub(/\&amp;/,"\\&",s);
  gsub(/\&quot;/,"\"",s);
  gsub(/\&lt;/,"<",s);
  gsub(/\&gt;/,">",s);
  return s;
}

function read_strings(fn,srt_arr,    s_key,s_val,r){
  while(r = getline s_key < fn){
    if(r == -1){
      print "ERROR: " fn " - " ERRNO;
      return -1;
    }
    r = getline s_val < fn
    srt_arr[s_key] = s_val;
  }
  return 0;
}

function read_ptn(fn,  i){
  ptn_count = 0;
  while (getline < fn){
    if($0 ~ /^<!##########/)
      ptn_count++;
    else
      ptn_src[ptn_count] = ptn_src[ptn_count] $0 "\n";
  }
  close(fn);
  ptn_count++;
  for(i=0; i<ptn_count; i++)
    ptn_cur[i] = ptn_src[i];
}

# Return
# 0 - tag sentence closed
# 1 - tag append
# 2 - no tags, add to value
function xml_read_line(str,   r,pri){
  pri = 2;
  s = trim(str);
  r = match(s, /^<[A-Z_]+>/);
  if(r > 0){
    cur_tag = substr(s,RSTART+1,RLENGTH-2);
    XML_SERV_TAGS = XML_SERV_TAGS " " cur_tag;
    sub(/^<[A-Z_]+>/,"",s);
    pri = 1;
  }
  r = match(s, /<\/[A-Z_]+>$/)
  if(r > 0){
    cur_tag = substr(s,RSTART+2,RLENGTH-3);
    sub(/<\/[A-Z_]+>$/ ,"",s);
    XML_SERV_VALUE = XML_SERV_VALUE s;
    XML_TAGS = XML_SERV_TAGS;
    XML_VALUE = XML_SERV_VALUE;
    sub(" " cur_tag "$", "", XML_SERV_TAGS);
    XML_SERV_VALUE = "";
    return 0;
  }
  XML_SERV_VALUE = XML_SERV_VALUE s;
  return pri;
}

# Return
# 0 - no rubbish
# 1 - <!--[if
# 2 - <img src="data:image
function find_rubbish(str){
  if(index(str,GB_STR["IF_WORD"])) return 1;
  if(index(str,GB_STR["BAD_IMG"])) return 2;
  return 0;
}

BEGIN{
  read_strings("___str.___",GB_STR);
  read_strings("___inf.___",GB_INF);
  read_ptn("_ptn.__h");
  XML_TAGS  = "";
  XML_VALUE = "";
  XML_SERV_TAGS  = "";
  XML_SERV_VALUE = "";
  fn = "..\_error_id.html";
  nerr = 0;
}

/<\?xml version="1.0" encoding="UTF-8"\?>/{next;}

{
  res = xml_read_line($0);
  if(res) next;
  sv = HTML_restore(XML_VALUE);
  if(XML_TAGS in GB_INF) {
    GB_INF[XML_TAGS] = sv;
    if(XML_TAGS == " MOODLE_BACKUP COURSE HEADER FULLNAME"){
      id = GB_INF[" MOODLE_BACKUP COURSE HEADER ID"];
      fn = sprintf("..\\cr%5.5d.html",id);
      printf("cr%5.5d.html###%s\n",id,sv);
      ptn_cur[0] = ptn_src[0];
      gsub(/==CRID==/,id,ptn_cur[0]);
      gsub(/==CRNAME==/,sv,ptn_cur[0]);
      printf(ptn_cur[0]) > fn;
    }
  }
  if(find_rubbish(sv)){
    ptn_cur[1] = ptn_src[1];
    gsub(/==NO==/,++nerr,ptn_cur[1]);
    gsub(/==TG==/,XML_TAGS,ptn_cur[1]);
    gsub(/==S0==/,sv,ptn_cur[1]);
#     gsub(/==S1==/,XML_VALUE,ptn_cur[1]);
    printf(ptn_cur[1]) > fn;
  }
}

END{
  printf(ptn_cur[2]) > fn;
}

